                     MEMBER('DASDEMO.clw')        ! This is a MEMBER module
 !-DAS-COMMENTS-------------------------------------------------------------------------------------------
 !
 ! DateRoutines - Test Date Routines
 ! Created  -  2/12/96 10:46AM
 ! Changed  -  7/19/96  9:33PM
 ! 
 !
 ! Sample Comments
 !
 !-DAS-COMMENTS-------------------------------------------------------------------------------------------
DateRoutines PROCEDURE

LocalRequest         LONG
DasNextBDay          LONG
DasNumDays           LONG
OriginalRequest      LONG
LocalResponse        LONG
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG
ClaDate              DATE
DosShort             USHORT(8272)
MonthIn              BYTE(6)
DayIn                BYTE(15)
YearIn               SHORT(1996)
DateIn               LONG
LowDate              DATE
HighDate             DATE
DateValid            BYTE
DayOfWk0             STRING(5)
DayOfWk1             STRING(9)
DayOfWkN             USHORT
IsAWkDay             USHORT
LeapYear             USHORT
IsLastDy             USHORT
DaysInMn             USHORT
DayOfYr              USHORT
WeekOfYr             USHORT
QtrOfYr              USHORT
DaysLfYr             USHORT
FMatDate0            STRING(30)
FmatDate1            STRING(30)
MonOfYr0             STRING(20)
MonOfYr1             STRING(20)
JulDate              STRING(20)
FindAge              STRING(30)
CDateDos             USHORT
DosDateC             DATE
_Date                LONG
DasBusDays           LONG
NumDays              SHORT
DasFiscalQtr         LONG
DasWorkDays          LONG
FilesOpened          LONG
window               WINDOW('DAS_Tools For Windows -  Date Routines'),AT(,,391,241),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
                       SPIN(@d1),AT(141,15),TIP('Date in Clarion format to be used in many routines.'),USE(DateIn)
                       SPIN(@d2),AT(207,15),TIP('Start Date in Clarion Format for FindAge Routine.'),USE(LowDate)
                       SPIN(@d2),AT(282,15),TIP('End Date in Calrion Format for FindAge Routine.'),USE(HighDate)
                       PROMPT('(DateIn)'),AT(153,4),USE(?DateIn:Prompt)
                       PROMPT('(LowDate)'),AT(219,4),USE(?LowDate:Prompt)
                       PROMPT('(HighDate)'),AT(294,4),USE(?HighDate:Prompt)
                       SHEET,AT(12,31,367,182),USE(?Sheet1)
                         TAB('Page 1'),USE(?Tab1)
                           ENTRY(@n1),AT(123,50),TIP('Returns 0 = Valid Date, 1 = Invalid Date.'),USE(DateValid),READONLY
                           STRING('O = Valid Date ,  1 = InValid Date'),AT(175,51),FONT(,,0FF0000H,),USE(?String6)
                           PROMPT('DAS_DateValid(DateIn)'),AT(32,52),USE(?DateValid:Prompt)
                           STRING('Abbreviation of day.'),AT(175,68),FONT(,,0FF0000H,),USE(?String7)
                           ENTRY(@s5),AT(123,68),TIP('Returns the day of the week for the date passed. (Short Form)'),USE(DayOfWk0),READONLY
                           PROMPT('DAS_DayOfWk(0,DateIn)'),AT(32,70),USE(?DayOfWk0:Prompt)
                           ENTRY(@s9),AT(123,86),TIP('Returns the day of the week for the date passed. (Long Form)'),USE(DayOfWk1),READONLY
                           PROMPT('DAS_DayOfWk(1,DateIn)'),AT(32,87),USE(?DayOfWk1:Prompt)
                           STRING('Name of day.'),AT(175,86),FONT(,,0FF0000H,),USE(?String8)
                           ENTRY(@n6),AT(123,102),TIP('Returns the day of the week for the date passed.  (Numeric)'),USE(DayOfWkN),READONLY
                           PROMPT('DAS_DayOfWkN(DateIn)'),AT(32,104),USE(?DayOfWkN:Prompt)
                           STRING('Day of Week, 0 = Sunday,....., 6 = Saturday.'),AT(175,103),FONT(,,0FF0000H,),USE(?String9)
                           ENTRY(@n6),AT(123,119),TIP('Checks to see if day of date passed is a week day.'),USE(IsAWkDay),READONLY
                           STRING('Business day?  0 = No, 1 = Monday,..., 5 = Friday'),AT(175,120),FONT(,,0FF0000H,),USE(?String10)
                           PROMPT('DAS_IsAWkDay(DateIn)'),AT(32,121),USE(?IsAWkDay:Prompt)
                           ENTRY(@n6),AT(123,137),TIP('Checks to see if year of date passed is a leap year. (Returns 0 = No, 1 = Yes)'),USE(LeapYear),READONLY
                           PROMPT('DAS_LeapYear(DateIn)'),AT(32,138),USE(?LeapYear:Prompt)
                           STRING('Leap year?  0 = No, 1 = Yes'),AT(175,137),FONT(,,0FF0000H,),USE(?String11)
                           ENTRY(@n6),AT(123,153),TIP('Tests if the day of date passed is the last day of month. (Returns 0=No, 1=Yes)'),USE(IsLastDy),READONLY
                           STRING('Last day of month?  0 = No, 1 = Yes'),AT(175,154),FONT(,,0FF0000H,),USE(?String12)
                           PROMPT('DAS_IsLastDy(DateIn)'),AT(32,155),USE(?IsLastDy:Prompt)
                           ENTRY(@n6),AT(123,170),TIP('Returns the days in the month for the date passed.'),USE(DaysInMn),READONLY
                           PROMPT('DAS_DaysInMn(DateIn)'),AT(32,172),USE(?DaysInMn:Prompt)
                           STRING('Numbers of days in the month.'),AT(175,171),FONT(,,0FF0000H,),USE(?String13)
                           ENTRY(@n6),AT(123,190),TIP('Returns the day of the year for the date passed.'),USE(DayOfYr),READONLY
                           PROMPT('DAS_DayOfYr(DateIn)'),AT(32,191),USE(?DayOfYr:Prompt)
                           STRING('Day of the year.'),AT(175,191),FONT(,,0FF0000H,),USE(?String14)
                         END
                         TAB('Page 2'),USE(?Tab2)
                           STRING('Week of year.'),AT(284,54),FONT(,,0FF0000H,),USE(?String15)
                           ENTRY(@n6),AT(148,52),TIP('Returns the week of the year for the date passed.'),USE(WeekOfYr),READONLY
                           PROMPT('DAS_WeekOfYr(DateIn)'),AT(19,54),USE(?WeekOfYr:Prompt)
                           ENTRY(@n6),AT(148,68),TIP('Returns the quarter of the year for the date passed.'),USE(QtrOfYr),READONLY
                           STRING('Quarter of year.'),AT(284,70),FONT(,,0FF0000H,),USE(?String16)
                           PROMPT('DAS_QtrOfYr(DateIn):'),AT(19,69),USE(?QtrOfYr:Prompt)
                           ENTRY(@n6),AT(148,84),TIP('Returns the days left in the year from the date passed.'),USE(DaysLfYr),READONLY
                           PROMPT('DAS_DaysLfYr(DateIn)'),AT(19,85),USE(?DaysLfYr:Prompt)
                           STRING('Days left in year.'),AT(284,87),FONT(,,0FF0000H,),USE(?String17)
                           ENTRY(@s30),AT(148,100),TIP('Returns a formatted date for the date passed. (Short Form)'),USE(FMatDate0),READONLY
                           STRING('Format date - Short form'),AT(284,102),FONT(,,0FF0000H,),USE(?String18)
                           PROMPT('DAS_FmatDate(0,DateIn)'),AT(19,101),USE(?FMatDate0:Prompt)
                           ENTRY(@s30),AT(148,116),TIP('Returns a formatted date for the date passed. (Long Form)'),USE(FmatDate1),READONLY
                           PROMPT('DAS_FmatDate(1,DateIn)'),AT(19,117),USE(?FmatDate1:Prompt)
                           STRING('Format date - Long form'),AT(284,118),FONT(,,0FF0000H,),USE(?String19)
                           ENTRY(@s20),AT(148,132),TIP('Returns the month of the year for the date passed.  (Short Form)'),USE(MonOfYr0),READONLY
                           PROMPT('DAS_MonOfYr(0,DateIn)'),AT(19,133),USE(?MonOfYr0:Prompt)
                           STRING('Month of year - Short form'),AT(284,134),FONT(,,0FF0000H,),USE(?String20)
                           ENTRY(@s20),AT(148,148),TIP('Returns the month of the year for the passed date. (Long Form)'),USE(MonOfYr1),READONLY
                           PROMPT('DAS_MonOfYr(1,DateIn)'),AT(19,149),USE(?MonOfYr1:Prompt)
                           STRING('Month of year - Long form'),AT(284,150),FONT(,,0FF0000H,),USE(?String21)
                           ENTRY(@s20),AT(148,164),TIP('Returns a string containing the Julian date of the date passed.'),USE(JulDate),READONLY
                           PROMPT('DAS_JulDate(DateIn)'),AT(19,165),USE(?JulDate:Prompt)
                           STRING('Julian date'),AT(284,166),FONT(,,0FF0000H,),USE(?String22)
                           ENTRY(@s30),AT(148,182),TIP('Returns a string containing the age between two dates passed.'),USE(FindAge),READONLY
                           PROMPT('DAS_FindAge(LowDate,HighDate)'),AT(19,183),USE(?FindAge:Prompt)
                           STRING('Find Age'),AT(284,183),FONT(,,0FF0000H,),USE(?String23)
                         END
                         TAB('Page 3'),USE(?Tab3)
                           BOX,AT(200,55,171,57),USE(?Box2),COLOR(00H)
                           SPIN(@n6),AT(293,66),USE(DosShort)
                           PROMPT('(DosShort)'),AT(243,69),USE(?DosShort:Prompt)
                           SPIN(@d2),AT(103,68,47,12),USE(ClaDate)
                           PROMPT('(ClaDate)'),AT(65,68),USE(?ClaDate:Prompt)
                           ENTRY(@n6),AT(130,87),TIP('Returns a ushort containing the Date in DOS format converted from Clarion format'),USE(CDateDos),READONLY
                           PROMPT('DAS_CDateDos(ClaDate)'),AT(42,87),USE(?CDateDos:Prompt)
                           SPIN(@n2),AT(95,146),TIP('Month of Year'),USE(MonthIn),RANGE(1,12),STEP(1)
                           PROMPT('(MonthIn)'),AT(112,136),USE(?MonthIn:Prompt)
                           ENTRY(@d2),AT(306,87),TIP('Returns a long(Date) containing the DOS Date converted to Clarion Format.'),USE(DosDateC),SKIP,READONLY
                           STRING('Convert Clarion Date to DOS format.'),AT(47,57),FONT(,,0FF0000H,),USE(?String24)
                           STRING('Convert DOS Date to Clarion format.'),AT(225,57),FONT(,,0FF0000H,),USE(?String25)
                           PROMPT('DAS_DosDateC(DosShort)'),AT(211,87),USE(?DosDateC:Prompt)
                           SPIN(@n2),AT(166,146),TIP('Day of Month'),USE(DayIn),RANGE(1,31),STEP(1)
                           PROMPT('(DayIn)'),AT(187,136),USE(?DayIn:Prompt)
                           SPIN(@n_4),AT(238,146),TIP('Year, if omitted the current year is used.'),USE(YearIn),RANGE(1900,2080)
                           PROMPT('(YearIn)'),AT(258,136),USE(?YearIn:Prompt)
                           ENTRY(@D4),AT(211,167),TIP('Returns the date in Clarion format from the month, day and year passed.'),USE(_Date),SKIP,READONLY
                           PROMPT('DAS_Date(MonthIn,DayIn,YearIn)'),AT(97,167),USE(?_Date:Prompt)
                           BOX,AT(21,55,171,57),USE(?Box2:2),COLOR(00H)
                           BOX,AT(81,124,233,65),USE(?Box1),COLOR(00H)
                           STRING('Returns a Clarion Date from passed parameters.'),AT(125,126),FONT(,,0FF0000H,),USE(?String26)
                         END
                         TAB('Page 4'),USE(?Tab5)
                           ENTRY(@n-13),AT(146,56,54,10),USE(DasBusDays),READONLY
                           BOX,AT(15,73,188,33),USE(?Box4),COLOR(00H)
                           SPIN(@n-6),AT(89,76),USE(NumDays)
                           PROMPT('(NumDays)'),AT(39,78),USE(?NumDayss:Prompt)
                           PROMPT('Das_BusDays(LowDate,HighDate)'),AT(20,56),USE(?DasBusDays:Prompt)
                           ENTRY(@d2),AT(146,90,54,10),USE(DasNextBDay),READONLY
                           STRING('(Returns next business day after NumDays passed)'),AT(207,90),FONT(,,0800000H,),USE(?String30)
                           PROMPT('Das_NextBDay(Today,Numdays)'),AT(20,90),USE(?DasNextBDay:Prompt)
                           ENTRY(@n-13),AT(146,111,54,10),USE(DasNumDays),READONLY
                           STRING('(Number of days between two dates)'),AT(207,111),FONT(,,0800000H,),USE(?String31)
                           ENTRY(@n-13),AT(146,125,54,10),USE(DasFiscalQtr),READONLY
                           ENTRY(@n-13),AT(146,139,54,10),USE(DasWorkDays),READONLY
                           PROMPT('Das_WorkDays(LowDate,Today(),0,0)'),AT(20,140),USE(?DasWorkDays:Prompt)
                           STRING('(Number of business days between dates)'),AT(207,56),FONT('MS Sans Serif',8,0800000H,),USE(?String29)
                           STRING('(Returns the Qtr of Year)'),AT(207,125),FONT('MS Sans Serif',8,0800000H,),USE(?String28)
                           STRING('(Returns the number of working days between dates.)'),AT(207,139),FONT('MS Sans Serif',8,0800000H,FONT:regular),USE(?String27)
                           PROMPT('Das_FiscalQt(DateIn)'),AT(20,125),USE(?DasFiscalQtr:Prompt)
                           PROMPT('Das_NumDays(LowDate,HighDate)'),AT(20,111),USE(?DasNumDays:Prompt)
                         END
                         TAB('Page 5'),USE(?Tab4)
                           STRING('Demo''s Unavailable'),AT(49,58),FONT(,,,FONT:underline),USE(?String1)
                           STRING('Reason'),AT(177,58),FONT(,,,FONT:underline),USE(?String3)
                           STRING('Internal Function.  You may never need to use it.'),AT(177,73),USE(?String4)
                           STRING('DAS_DateParm'),AT(55,73),USE(?String2)
                           STRING('All functions requiring this function will automatically call it.'),AT(177,82),USE(?String5)
                         END
                       END
                       BUTTON('Close'),AT(179,220),USE(?OkButton)
                     END
  CODE
  PUSHBIND
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF KEYCODE() = MouseRight
    SETKEYCODE(0)
  END
  FilesOpened = True
  OPEN(window)
  WindowOpened=True
  ! Before Embed Point: %BeforeAccept) DESC(Preparing to Process the Window) ARG()
  datein       = Today()
  datevalid    = DAS_DateValid(dateIn)
                 DAS_DateParm(dateIn)
  dayofwk1     = DAS_DayOfWk(1,dateIn)
  dayofwk0     = DAS_DayOfWk(0,dateIn)
  dayofwkn     = DAS_DayOfWkn(datein)
  isawkday     = DAS_IsAWkDay(datein)
  leapyear     = DAS_LeapYear(datein)
  islastdy     = DAS_IsLastDy(datein)
  daysinmn     = DAS_DaysInMn(datein)
  dayofyr      = DAS_DayOfYr(datein)
  weekofyr     = DAS_WeekOfYr(datein)
  qtrofyr      = DAS_QtrOfYr(datein)
  dayslfyr     = DAS_DaysLfYr(datein)
  fmatdate1    = DAS_FmatDate(1,datein)
  monofyr1     = DAS_MonOfYr(1,datein)
  fmatdate0    = DAS_FmatDate(0,datein)
  monofyr0     = DAS_MonOfYr(0,datein)
  juldate      = DAS_JulDate(datein)
  cladate      = Today()
  cdatedos     = DAS_CDateDos(cladate)
  dosshort     = 8272
  dosdatec     = DAS_DosDateC(dosshort)
  _date        = DAS_Date(monthin,dayin,yearin)
  lowdate      = Today() - 13000
  highdate     = Today()
  findage      = DAS_FindAge(lowdate,highdate)
  dasfiscalqtr = DAS_FiscalQtr(datein)
  dasbusdays   = DAS_BusDays(lowdate,highdate)
  dasnumdays   = DAS_NumDays(lowdate,highdate)
  dasworkdays  = DAS_WorkDays(lowdate,Today(),0,0)
  numdays      = 1
  dasnextbday  = DAS_NextBDay(Today(),numdays)
  DISPLAY
  
  ! After Embed Point: %BeforeAccept) DESC(Preparing to Process the Window) ARG()
  ACCEPT
    !-TINMAN-SOFTWARE-DATE-FIX------------------------------------------------
      IF EVENT() = EVENT:Accepted
        CASE FIELD()
        OF ?DosDateC
          IF DosDateC AND YEAR(DosDateC) < 1980
            DosDateC=DATE(MONTH(DosDateC),DAY(DosDateC),YEAR(DosDateC)+100)
            DISPLAY(?DosDateC)
          END
        OF ?_Date
          IF _Date AND YEAR(_Date) < 1980
            _Date=DATE(MONTH(_Date),DAY(_Date),YEAR(_Date)+100)
            DISPLAY(?_Date)
          END
        OF ?DasNextBDay
          IF DasNextBDay AND YEAR(DasNextBDay) < 1980
            DasNextBDay=DATE(MONTH(DasNextBDay),DAY(DasNextBDay),YEAR(DasNextBDay)+100)
            DISPLAY(?DasNextBDay)
          END
        END
      END
    !-TINMAN-SOFTWARE-DATE-FIX------------------------------------------------
    CASE EVENT()
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(?DateIn)
    OF EVENT:GainFocus
      ForceRefresh = True
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      ELSE
        DO RefreshWindow
      END
    OF Event:Rejected
      BEEP
      DISPLAY(?)
      SELECT(?)
    END
    CASE FIELD()
    OF ?DateIn
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DateIn, NewSelection)
        datevalid    = DAS_DateValid(dateIn)
                       DAS_DateParm(dateIn)
        dayofwk1     = DAS_DayOfWk(1,dateIn)
        dayofwk0     = DAS_DayOfWk(0,dateIn)
        dayofwkn     = DAS_DayOfWkn(datein)
        isawkday     = DAS_IsAWkDay(datein)
        leapyear     = DAS_LeapYear(datein)
        islastdy     = DAS_IsLastDy(datein)
        daysinmn     = DAS_DaysInMn(datein)
        dayofyr      = DAS_DayOfYr(datein)
        weekofyr     = DAS_WeekOfYr(datein)
        qtrofyr      = DAS_QtrOfYr(datein)
        dayslfyr     = DAS_DaysLfYr(datein)
        fmatdate1    = DAS_FmatDate(1,datein)
        monofyr1     = DAS_MonOfYr(1,datein)
        fmatdate0    = DAS_FmatDate(0,datein)
        monofyr0     = DAS_MonOfYr(0,datein)
        juldate      = DAS_JulDate(datein)
        findage      = DAS_FindAge(lowdate,highdate)
        dasfiscalqtr = DAS_FiscalQtr(datein)
        DISPLAY
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DateIn, NewSelection)
      END
    OF ?LowDate
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?LowDate, NewSelection)
        findage     = DAS_FindAge(lowdate,highdate)
        dasbusdays  = DAS_BusDays(lowdate,highdate)
        dasnumdays  = DAS_NumDays(lowdate,highdate)
        dasworkdays = DAS_WorkDays(lowdate,Today(),0,0)
        DISPLAY
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?LowDate, NewSelection)
      END
    OF ?HighDate
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?HighDate, NewSelection)
        findage    = DAS_FindAge(lowdate,highdate)
        dasnumdays = DAS_NumDays(lowDate,highdate)
        dasbusdays = DAS_BusDays(lowdate,highdate)
        DISPLAY
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?HighDate, NewSelection)
      END
    OF ?Sheet1
      CASE EVENT()
      OF EVENT:Accepted
        DO RefreshWindow
      OF EVENT:NewSelection
        DO RefreshWindow
      OF EVENT:TabChanging
        DO RefreshWindow
      OF EVENT:Selected
        DO RefreshWindow
      END
    OF ?DosShort
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DosShort, NewSelection)
        DosDateC = DAS_DosDateC(DosShort)
        Display
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DosShort, NewSelection)
      END
    OF ?ClaDate
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?ClaDate, NewSelection)
        CDateDos = DAS_CDateDos(ClaDate)
        Display
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?ClaDate, NewSelection)
      END
    OF ?MonthIn
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?MonthIn, NewSelection)
        _Date = DAS_Date(MonthIn,DayIn,YearIn)
        Display
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?MonthIn, NewSelection)
      END
    OF ?DayIn
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DayIn, NewSelection)
        _Date = DAS_Date(MonthIn,DayIn,YearIn)
        Display
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?DayIn, NewSelection)
      END
    OF ?YearIn
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?YearIn, NewSelection)
        _Date = DAS_Date(MonthIn,DayIn,YearIn)
        Display
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?YearIn, NewSelection)
      END
    OF ?NumDays
      CASE EVENT()
      OF EVENT:NewSelection
        ! Before Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?NumDays, NewSelection)
        DasNextBDay = DAS_NextBDay(Today(),numdays)
        DISPLAY
        ! After Embed Point: %ControlPreEventHandling) DESC(Control Event Handling, before generated code) ARG(?NumDays, NewSelection)
      END
    OF ?OkButton
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ! Before Embed Point: %ControlPostEventHandling) DESC(Control Event Handling, after generated code) ARG(?OkButton, Accepted)
        Do ProcedureReturn
        ! After Embed Point: %ControlPostEventHandling) DESC(Control Event Handling, after generated code) ARG(?OkButton, Accepted)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
!|
!| This routine provides a common procedure exit point for all template
!| generated procedures.
!|
!| First, all of the files opened by this procedure are closed.
!|
!| Next, if it was opened by this procedure, the window is closed.
!|
!| Next, GlobalResponse is assigned a value to signal the calling procedure
!| what happened in this procedure.
!|
!| Next, we replace the BINDings that were in place when the procedure initialized
!| (and saved with PUSHBIND) using POPBIND.
!|
!| Finally, we return to the calling procedure.
!|
  IF FilesOpened
  END
  IF WindowOpened
    CLOSE(window)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  POPBIND
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
!|
!| This routine is used to prepare any control templates for use. It should be called once
!| per procedure.
!|
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
!|
!| This routine is used to keep all displays and control templates current.
!|
  IF window{Prop:AcceptAll} THEN EXIT.
  DISPLAY()
  ForceRefresh = False
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!|
!| This routine is used to insure that any records pointed to in control
!| templates are fetched before any procedures are called via buttons or menu
!| options.
!|
!---------------------------------------------------------------------------
