   PROGRAM

 !-DAS-COMMENTS-------------------------------------------------------------------------------------------
 !
 ! Application - DASDEMO
 ! Author      - Gary Reichenberger
 ! Dictionary  - 
 ! Help        - DASTOOLS.HLP
 ! Program     - DASDEMO.clw
 ! Type        - EXE
 ! Compiler    - 16 bit
 ! Created  -  2/12/96 10:46AM
 ! Changed  -  7/19/96  9:50PM
 ! 
 !
 ! Sample Comments For Application
 !
 !-DAS-COMMENTS-------------------------------------------------------------------------------------------
   INCLUDE('Equates.CLW')
   INCLUDE('TplEqu.CLW')
   INCLUDE('Keycodes.CLW')
   INCLUDE('Errors.CLW')
INCLUDE('DASEQU.CLW')
   MAP
     MODULE('DASDE001.clw')
       DateRoutines
     END
     MODULE('DASDE002.clw')
       Main
     END
     MODULE('DASDE003.clw')
       TimeRoutines
     END
     MODULE('DASDE004.clw')
       DASParse
     END
     MODULE('DASDE005.clw')
       DASSalute
     END
     MODULE('DASDE006.clw')
       DASCapsstr
     END
     MODULE('DASDE007.clw')
       DASMsgFunc
     END
     MODULE('DASDE008.clw')
       Mesg_Help
     END
     MODULE('DASDE009.clw')
       DasErrorSave
     END
     MODULE('DASDE010.clw')
       Order_Form
     END
     MODULE('DASDE011.clw')
       RP_Order
     END
     MODULE('DASDE012.clw')
       SplashTime
     END
     MODULE('DASDE013.clw')
       SplashMouse
     END
     MODULE('DASDE014.clw')
       ApplStats
     END
     MODULE('DASDE015.clw')
       Procstats
     END
     MODULE('DASDE016.clw')
       IDLEITPROC
     END
     MODULE('DASDE017.clw')
       SplashStats
     END
     MODULE('DASDE018.clw')
       ErrorLogView
     END
     MODULE('DASDE_SF.CLW')
       CheckOpen(FILE File,<BYTE OverrideCreate>,<BYTE OverrideOpenMode>)
       ReportPreview(QUEUE PrintPreviewQueue)
       Preview:JumpToPage(LONG Input:CurrentPage, LONG Input:TotalPages),LONG
       Preview:SelectDisplay(*LONG Input:PagesAcross, *LONG Input:PagesDown)
       StandardWarning(LONG WarningID),LONG,PROC
       StandardWarning(LONG WarningID,STRING WarningText1),LONG,PROC
       StandardWarning(LONG WarningID,STRING WarningText1,STRING WarningText2),LONG,PROC
       SetupStringStops(STRING ProcessLowLimit,STRING ProcessHighLimit,LONG InputStringSize,<LONG ListType>)
       NextStringStop,STRING
       SetupRealStops(REAL InputLowLimit,REAL InputHighLimit)
       NextRealStop,REAL
       INIRestoreWindow(STRING ProcedureName,STRING INIFileName)
       INISaveWindow(STRING ProcedureName,STRING INIFileName)
       RISaveError
     END
     MODULE('DASDE_RU.CLW')
     END
     MODULE('DASDE_RD.CLW')
     END
     !--(Start)--DAS_TOOLS Library Includes-----------------------------------
     INCLUDE('DASTOOLS.CLW','ToolboxLibrary')
     !--(End)--DAS_TOOLS Library Includes-------------------------------------
   END


Cus:Name   STRING(60)
MDIFRAME   &WINDOW
Cus:Company   STRING(60)
Cus:Address1   STRING(60)
Cus:Address2   STRING(60)
Cus:CSZ   STRING(60)
Cus:WkPhone   STRING(20)
Cus:HmPhone   STRING(20)
Cus:FaxPhone   STRING(20)
Cus:EMail   STRING(80)
Cus:CWTools   BYTE(1)
Cus:CWSec   BYTE
Cus:KS   BYTE
Cus:US   BYTE
ASCIIFileName   CSTRING(80)

SaveErrorCode        LONG
SaveError            CSTRING(255)
SaveFileErrorCode    LONG
SaveFileError        CSTRING(255)
GlobalRequest        LONG(0),THREAD
GlobalResponse       LONG(0),THREAD
Sort:Name STRING(ScrollSort:Name)
Sort:Name:Array STRING(3),DIM(100),OVER(Sort:Name)
Sort:Alpha STRING(ScrollSort:Alpha)
Sort:Alpha:Array STRING(2),DIM(100),OVER(Sort:Alpha)
!--(Start)--DAS_Tools Global Includes-----------------------------------
INCLUDE('DASTOOLS.CLW','DasToolsGlobal')
!--(End)--DAS_Tools Global Includes-----------------------------------
  CODE
  HELP('DASTOOLS.HLP')
   DAS::PGMNAME        = 'DASDEMO.clw'
   DAS::APPLTITLE      = 'DasDemo'
   DAS::COPYRIGHT      = 'Tin Man Software'
   DAS::COMPANY        = 'Tin Man Software'
   DAS::ISBN           = '0-933735-05-7'
   DAS::VERSION        = 1
   DAS::MINOR          = 1
   DAS::BUILDNUM       = 1
   DAS::32BITSET       = 0
  
   DAS::PGMDATECREATED = 71268               !  2/12/96
   DAS::PGMTIMECREATED = 3877933             ! 10:46AM
  !--(Start)--DAS_ErrorSave StartUp Code-----------------------------------
    DAS::ErPgmName   = 'DASDEMO.EXE'
    DAS::ErProcName  = ' '
    DAS::ErUserName  = ' '
  !--(End)--DAS_ErrorSave StartUp Code-------------------------------------
  Main
!---------------------------------------------------------------------------

